#include "PacketParser.h"
#include "Base64.h"
#include <stdio.h>
#include <time.h>
#include "NatasConfig.h"

char *Protocol[]={ 
		           "Reserved",     //  0
                   "ICMP",         //  1
                   "IGMP",         //  2
                   "GGP",          //  3
                   "IP",           //  4
                   "ST",           //  5
                   "TCP",          //  6
                   "UCL",          //  7
                   "EGP",          //  8
                   "IGP",          //  9
                   "BBN-RCC-MON",  // 10
                   "NVP-II",       // 11
                   "PUP",          // 12
                   "ARGUS",        // 13
                   "EMCON",        // 14
                   "XNET",         // 15
                   "CHAOS",        // 16
                   "UDP",          // 17
                   "MUX",          // 18
                   "DCN-MEAS",     // 19
                   "HMP",          // 20
                   "PRM",          // 21
                   "XNS-IDP",      // 22
                   "TRUNK-1",      // 23
                   "TRUNK-2",      // 24
                   "LEAF-1",       // 25
                   "LEAF-2",       // 26
                   "RDP",          // 27
                   "IRTP",         // 28
                   "ISO-TP4",      // 29
                   "NETBLT",       // 30
                   "MFE-NSP",      // 31
                   "MERIT-INP",    // 32
                   "SEP",          // 33
                   "3PC",          // 34
                   "IDPR",         // 35
                   "XTP",          // 36
                   "DDP",          // 37
                   "IDPR-CMTP",    // 38
                   "TP++",         // 39
                   "IL",           // 40
                   "SIP",          // 41
                   "SDRP",         // 42
                   "SIP-SR",       // 43
                   "SIP-FRAG",     // 44
                   "IDRP",         // 45
                   "RSVP",         // 46
                   "GRE",          // 47
                   "MHRP",         // 48
                   "BNA",          // 49
                   "SIPP-ESP",     // 50
                   "SIPP-AH",      // 51
                   "I-NLSP",       // 52
                   "SWIPE",        // 53
                   "NHRP",         // 54
                   "unknown",      // 55
                   "unknown",      // 56
                   "unknown",      // 57
                   "unknown",      // 58
                   "unknown",      // 59
                   "unknown",      // 60
                   "unknown",      // 61
                   "CFTP",         // 62
                   "unknown",      // 63
                   "SAT-EXPAK",    // 64
                   "KRYPTOLAN",    // 65
                   "RVD",          // 66
                   "IPPC",         // 67
                   "unknown",      // 68
                   "SAT-MON",      // 69
                   "VISA",         // 70
                   "IPCV",         // 71
                   "CPNX",         // 72
                   "CPHB",         // 73
                   "WSN",          // 74
                   "PVP",          // 75
                   "BR-SAT-MON",   // 76
                   "SUN-ND",       // 77
                   "WB-MON",       // 78
                   "WB-EXPAK",     // 79
                   "ISO-IP",       // 80
                   "VMTP",         // 81
                   "SECURE-VMTP",  // 82
                   "VINES",        // 83
                   "TTP",          // 84
                   "NSFNET-IGP",   // 85
                   "DGP",          // 86
                   "TCF",          // 87
                   "IGRP",         // 88
                   "OSPFIGP",      // 89
                   "Sprite-RPC",   // 90
                   "LARP",         // 91
                   "MTP",          // 92
                   "AX.25",        // 93
                   "IPIP",         // 94
                   "MICP",         // 95
                   "SCC-SP",       // 96
                   "ETHERIP",      // 97
                   "ENCAP",        // 98
                   "unknown",      // 98
                   "GMTP"          // 99
                  };

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPacketParser::CPacketParser()
{

}

CPacketParser::~CPacketParser()
{

}

CPacketParser::PassCap(char *logfilename, WSABUF *wsb)
{
	FILE *logfile=fopen(logfilename,"a+");
	int i;	

	// pop3 login || password
	i=45;
	if((BYTE)wsb->buf[22]*256+(BYTE)wsb->buf[23]==110) {
	
		if((BYTE)wsb->buf[40]==0x55 &&  // U
		   (BYTE)wsb->buf[41]==0x53 &&  // S
		   (BYTE)wsb->buf[42]==0x45 &&  // E
		   (BYTE)wsb->buf[43]==0x52 &&  // R
		   (BYTE)wsb->buf[44]==0x20 ) { // %SPACE%

			WriteTime(logfile);

			fprintf(logfile,"User from %d.%d.%d.%d / Pop3 Server Address: %d.%d.%d.%d   ->  login: ",(BYTE)wsb->buf[12],(BYTE)wsb->buf[13],(BYTE)wsb->buf[14],(BYTE)wsb->buf[15],(BYTE)wsb->buf[16],(BYTE)wsb->buf[17],(BYTE)wsb->buf[18],(BYTE)wsb->buf[19]);
			while((BYTE)wsb->buf[i]!=0x0d) {
				fprintf(logfile,"%c",(BYTE)wsb->buf[i]);
				i++;
			}
			fprintf(logfile,"\n");
		}

		if((BYTE)wsb->buf[40]==0x50 &&  // P
		   (BYTE)wsb->buf[41]==0x41 &&  // A
		   (BYTE)wsb->buf[42]==0x53 &&  // S
		   (BYTE)wsb->buf[43]==0x53 &&  // S
		   (BYTE)wsb->buf[44]==0x20 ) { // %SPACE%

			WriteTime(logfile);

			fprintf(logfile,"User from %d.%d.%d.%d / Pop3 Server Address: %d.%d.%d.%d   ->  passwd: ",(BYTE)wsb->buf[12],(BYTE)wsb->buf[13],(BYTE)wsb->buf[14],(BYTE)wsb->buf[15],(BYTE)wsb->buf[16],(BYTE)wsb->buf[17],(BYTE)wsb->buf[18],(BYTE)wsb->buf[19]);			
			while((BYTE)wsb->buf[i]!=0x0d) {
				fprintf(logfile,"%c",(BYTE)wsb->buf[i]);
				i++;
			}
			fprintf(logfile,"\n");
		}
	}
    // -------------------------------------------------------------------

	// ftp login || password
	i=45;
	if((BYTE)wsb->buf[22]*256+(BYTE)wsb->buf[23]==21) {

		if((BYTE)wsb->buf[40]==0x55 &&  // U
		   (BYTE)wsb->buf[41]==0x53 &&  // S
		   (BYTE)wsb->buf[42]==0x45 &&  // E
		   (BYTE)wsb->buf[43]==0x52 &&  // R
		   (BYTE)wsb->buf[44]==0x20 ) { // %SPACE%

			WriteTime(logfile);
			
			fprintf(logfile,"User from %d.%d.%d.%d / FTP Server Address: %d.%d.%d.%d   ->  login: ",(BYTE)wsb->buf[12],(BYTE)wsb->buf[13],(BYTE)wsb->buf[14],(BYTE)wsb->buf[15],(BYTE)wsb->buf[16],(BYTE)wsb->buf[17],(BYTE)wsb->buf[18],(BYTE)wsb->buf[19]);
			while((BYTE)wsb->buf[i]!=0x0d) {
				fprintf(logfile,"%c",(BYTE)wsb->buf[i]);
				i++;
			}
			fprintf(logfile,"\n");
		}

		if( ((BYTE)wsb->buf[40]==0x50 &&  // P
		     (BYTE)wsb->buf[41]==0x41 &&  // A
		     (BYTE)wsb->buf[42]==0x53 &&  // S
		     (BYTE)wsb->buf[43]==0x53 &&  // S
		     (BYTE)wsb->buf[44]==0x20) || // %SPACE%
		 // gro oder kleingeschrieben erlaubt   
			((BYTE)wsb->buf[40]==0x70 &&  // p
		     (BYTE)wsb->buf[41]==0x61 &&  // a
		     (BYTE)wsb->buf[42]==0x73 &&  // s
		     (BYTE)wsb->buf[43]==0x73 &&  // s
			 (BYTE)wsb->buf[44]==0x20)  ){// %SPACE%

			WriteTime(logfile);

			fprintf(logfile,"User from %d.%d.%d.%d / FTP Server Address: %d.%d.%d.%d   ->  passwd: ",(BYTE)wsb->buf[12],(BYTE)wsb->buf[13],(BYTE)wsb->buf[14],(BYTE)wsb->buf[15],(BYTE)wsb->buf[16],(BYTE)wsb->buf[17],(BYTE)wsb->buf[18],(BYTE)wsb->buf[19]);			
			while((BYTE)wsb->buf[i]!=0x0d) {
				fprintf(logfile,"%c",(BYTE)wsb->buf[i]);
				i++;
			}
			fprintf(logfile,"\n");
		}
	}
	// -------------------------------------------------------------------
	
	// basic http authorization
	if((BYTE)wsb->buf[22]*256+(BYTE)wsb->buf[23]==80) {		
		char tmp[4096];
		char coded[100];
		char decoded[100];
		char location[500];
		int position=4;
		int i=0;
		CBase64 *codeengine=new CBase64;
		char ab[]="Authorization: Basic";

		ZeroMemory(coded,100);
		ZeroMemory(decoded,100);
		ZeroMemory(location,500);
		ZeroMemory(tmp,4096);

		memcpy(&tmp,wsb->buf+40,wsb->len-40);
		tmp[wsb->len-38]=0x00;

		if(tmp[0]=='G' && tmp[1]=='E' && tmp[2]=='T') {

			
			while(tmp[position]!=0x20) {
				location[i]=tmp[position];
				i++;
				position++;
			}

			position++;			

			while(position-15 < (signed)wsb->len-40) {

				// Authorization: Basic
				if( tmp[position]    =='A' &&
					tmp[position+1]  =='u' &&
					tmp[position+2]  =='t' &&
					tmp[position+3]  =='h' &&
					tmp[position+4]  =='o' &&
					tmp[position+5]  =='r' &&
					tmp[position+6]  =='i' &&
					tmp[position+7]  =='z' &&
					tmp[position+8]  =='a' &&
					tmp[position+9]  =='t' &&
					tmp[position+10] =='i' &&
					tmp[position+11] =='o' &&
					tmp[position+12] =='n' &&
					tmp[position+13] ==':' &&
					tmp[position+14] ==' ' &&
					tmp[position+15] =='B' &&
					tmp[position+16] =='a' &&
					tmp[position+17] =='s' &&
					tmp[position+18] =='i' &&
					tmp[position+19] =='c' ) {

					position+=21;
					i=0;
					while(tmp[position]!=0x0d) {
						coded[i]=tmp[position];
						i++;
						position++;
					}

					codeengine->base64decode((char*)&coded,(char*)&decoded);

					WriteTime(logfile);

					fprintf(logfile,"User from %d.%d.%d.%d : http://%s@%d.%d.%d.%d%s\n",(BYTE)wsb->buf[12],(BYTE)wsb->buf[13],(BYTE)wsb->buf[14],(BYTE)wsb->buf[15],&decoded,(BYTE)wsb->buf[16],(BYTE)wsb->buf[17],(BYTE)wsb->buf[18],(BYTE)wsb->buf[19],&location);					
				}
				position++;
			}
		}
	}
	fclose(logfile);
	// -------------------------------------------------------------------
}

CPacketParser::DecodeToLogfile(char *logfilename, WSABUF *wsabuf)
{
	FILE *logfile=fopen(logfilename,"a+");
	unsigned int i,y;
	char *service;
	WSABUF wab;
	WSABUF *wsb;

	wsb=&wab;
	memcpy(wsb,wsabuf,sizeof(WSABUF));
	
    WriteTime(logfile);

	fprintf(logfile,"Protocol: %s",Protocol[(BYTE)wsb->buf[9]]);

	service=GetServiceByPort((BYTE)wsb->buf[20]*256+(BYTE)wsb->buf[21]);
	if(strstr(service,"unknown")) service=GetServiceByPort((BYTE)wsb->buf[22]*256+(BYTE)wsb->buf[23]);
	fprintf(logfile,"\tService: %s\n",service);
	fprintf(logfile,"Source Address: %d.%d.%d.%d    Destination Address: %d.%d.%d.%d\n",(BYTE)wsb->buf[12],(BYTE)wsb->buf[13],(BYTE)wsb->buf[14],(BYTE)wsb->buf[15],(BYTE)wsb->buf[16],(BYTE)wsb->buf[17],(BYTE)wsb->buf[18],(BYTE)wsb->buf[19]);
	fprintf(logfile,"Source Port: %d    Destination Port: %d\n",(BYTE)wsb->buf[20]*256+(BYTE)wsb->buf[21],(BYTE)wsb->buf[22]*256+(BYTE)wsb->buf[23]);

	for(i=0;i<wsb->len;i++) {
		fprintf(logfile,"%02x ",(BYTE)wsb->buf[i]);

		if(!((i+1)%18)) {
			for(y=0;y<=17;y++) if(wsb->buf[i-y]<=0x1F) wsb->buf[i-y]=' '; // steuerzeichen entsorgen
				fprintf(logfile,"    %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c"
					,(BYTE)wsb->buf[i-17],(BYTE)wsb->buf[i-16],(BYTE)wsb->buf[i-15],(BYTE)wsb->buf[i-14]
					,(BYTE)wsb->buf[i-13],(BYTE)wsb->buf[i-12],(BYTE)wsb->buf[i-11],(BYTE)wsb->buf[i-10]
					,(BYTE)wsb->buf[i-9], (BYTE)wsb->buf[i-8], (BYTE)wsb->buf[i-7], (BYTE)wsb->buf[i-6]
					,(BYTE)wsb->buf[i-5], (BYTE)wsb->buf[i-4], (BYTE)wsb->buf[i-3], (BYTE)wsb->buf[i-2]
					,(BYTE)wsb->buf[i-1], (BYTE)wsb->buf[i]);
				fprintf(logfile,"\n");
		}
	}

	// zeile korregieren falls nicht voll
	for(y=wsb->len%18;y<18;y++)
		fprintf(logfile,"   ");
	
	fprintf(logfile,"    ");
	
	for(y=(wsb->len)-(wsb->len%18);y<wsb->len;y++)
		if(wsb->buf[y]<=0xF) fprintf(logfile," ");
		else fprintf(logfile,"%c",(BYTE)wsb->buf[y]);

	fprintf(logfile,"\n");
	fprintf(logfile,"----------------------------------------------------------------------------\n\n");    
	fclose(logfile);
}

char * CPacketParser::GetServiceByPort(unsigned short port)
{
	switch(port) {

	case 7:   return &"echo";
	case 13:  return &"daytime";
	case 21:  return &"FTP";
	case 22:  return &"SSH";
	case 23:  return &"telnet";
	case 25:  return &"SMTP";
	case 53:  return &"DNS";	
	case 80:  return &"HTTP";	
	case 110: return &"POP3";	
	case 119: return &"NNTP";	
	case 139: return &"nbsession";

	default: return &"unknown";
	}
}

BOOL CPacketParser::CheckFilter(WSABUF *wsb)
{
	CNatasConfig *theConfig=new CNatasConfig;
	char temp[200];

	theConfig->ReadConfigFromRegistry();

	if(theConfig->SourcePort==0 &&
	   theConfig->TargetPort==0 &&
	   strstr(theConfig->SourceAddress,&"0.0.0.0") &&
	   strstr(theConfig->TargetAddress,&"0.0.0.0")    ){
		   delete theConfig;
		   return TRUE;
	}

	if(theConfig->Combination==0) {
		if(theConfig->SourcePort==(BYTE)wsb->buf[20]*256+(BYTE)wsb->buf[21] || theConfig->SourcePort==0)
			if(theConfig->TargetPort==(BYTE)wsb->buf[22]*256+(BYTE)wsb->buf[23] || theConfig->TargetPort==0) {
				sprintf(temp,"%d.%d.%d.%d",(BYTE)wsb->buf[12],(BYTE)wsb->buf[13],(BYTE)wsb->buf[14],(BYTE)wsb->buf[15]);
				if(strstr(theConfig->SourceAddress,(char*)&temp) || strstr(theConfig->SourceAddress,&"0.0.0.0")) {
					sprintf(temp,"%d.%d.%d.%d",(BYTE)wsb->buf[16],(BYTE)wsb->buf[17],(BYTE)wsb->buf[18],(BYTE)wsb->buf[19]);
					if(strstr(theConfig->TargetAddress,(char*)&temp) || strstr(theConfig->TargetAddress,&"0.0.0.0")){
						delete theConfig;
						return TRUE;
					}
				}
			}
	} 
	else if(theConfig->Combination==1) {
		
		// source port kontrollieren
		if(theConfig->SourcePort!=0)
			if(theConfig->SourcePort==(BYTE)wsb->buf[20]*256+(BYTE)wsb->buf[21]){
				delete theConfig;
				return TRUE;
			}
			
		// target port kontrollieren
		if(theConfig->TargetPort!=0)
			if(theConfig->TargetPort==(BYTE)wsb->buf[22]*256+(BYTE)wsb->buf[23]){
				delete theConfig;
				return TRUE;
			}

		// source IP addresse kontrollieren
		if(!strstr(theConfig->SourceAddress,"0.0.0.0")) {
			sprintf(temp,"%d.%d.%d.%d",(BYTE)wsb->buf[12],(BYTE)wsb->buf[13],(BYTE)wsb->buf[14],(BYTE)wsb->buf[15]);
			if(strstr(theConfig->SourceAddress,(char*)&temp)){
				delete theConfig;
				return TRUE;
			}
		}

		// target IP addresse kontrollieren
		if(!strstr(theConfig->TargetAddress,"0.0.0.0")) {
			sprintf(temp,"%d.%d.%d.%d",(BYTE)wsb->buf[16],(BYTE)wsb->buf[17],(BYTE)wsb->buf[18],(BYTE)wsb->buf[19]);
			if(strstr(theConfig->TargetAddress,(char*)&temp)){
				delete theConfig;
				return TRUE;
			}
		}
	}
	
	delete theConfig;

	return FALSE;
}

CPacketParser::HTTPCap(char *logfilename, WSABUF *wsb)
{
	FILE *logfile=fopen(logfilename,"a+");

	if( ((BYTE)wsb->buf[22]*256+(BYTE)wsb->buf[23]==80) || 
		((BYTE)wsb->buf[22]*256+(BYTE)wsb->buf[23]==8080) ) {		
		char tmp[4096];
		char location[500];
		int position=4;
		int i=0;

		ZeroMemory(location,500);
		ZeroMemory(tmp,4096);

		memcpy(&tmp,wsb->buf+40,wsb->len-40);

		if(tmp[0]=='G' && tmp[1]=='E' && tmp[2]=='T') {

			WriteTime(logfile);

			fprintf(logfile,"User from %d.%d.%d.%d : http://%d.%d.%d.%d",(BYTE)wsb->buf[12],(BYTE)wsb->buf[13],(BYTE)wsb->buf[14],(BYTE)wsb->buf[15],(BYTE)wsb->buf[16],(BYTE)wsb->buf[17],(BYTE)wsb->buf[18],(BYTE)wsb->buf[19]);

			while(tmp[position]!=0x20) {
				location[i]=tmp[position];
				i++;
				position++;
			}
			fprintf(logfile,"%s\n",&location);			
		}
	}
	fclose(logfile);
}

void CPacketParser::WriteTime(FILE *logfile)
{
	SYSTEMTIME now;
	GetLocalTime(&now);
	fprintf(logfile,"%02d:%02d:%02d - %02d.%02d.%02d\t",now.wHour,now.wMinute,now.wSecond,now.wDay,now.wMonth,now.wYear);
}
